/*
    Fichier copiedepl.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Bibliothque des fonctions communes aux commandes deplacemail
    deplpartaille et deplpartiel .
*/

#include <stdio.h>
#include <string.h>
#include "messages.h"
#include "buflect.h"
#include "pop.h"
#include "smtp.h"
#include "copiedepl.h"



/* rcupre une adresse email dans le fichier de configuration dont
   le descripteur fconf est pass en paramtre, extrait l'adresse
   entre les < > s'ils existent et la mmorise dans bufadr */

void mem_adr (char *bufadr, FILE *fconf)
{
    char fin_adr [80]; // partie droite de l'adresse expditeur reconstitue
    long posit;        // position dans le fichier de configuration
    int  i, j;         // compteurs


    // lire une ligne du fichier de configuration
    fgets (buf_lect, sizeof (buf_lect), fconf);

    // rechercher le @ dans la ligne lue
    i = 0;

    while (buf_lect [i] != '@' && buf_lect [i])
        i++;

    // si trouv
    if (buf_lect [i] == '@')
    {
        // se positionner au dbut de l'adresse email
        do
            i--;
        while (i > 0 && buf_lect [i] != '<' && buf_lect [i] != ' '
                                            && buf_lect [i] != '\t');

        if (buf_lect [i] == '<' || buf_lect [i] == ' ' || buf_lect [i] == '\t')
            i++;

        // mmoriser l'adresse email
        j = 0;

        while (buf_lect [i] != '\n' && buf_lect [i] != '>' && buf_lect [i])
            bufadr [j++] = buf_lect [i++];

        bufadr [j] = '\0';
    }
    // sinon pour l'adresse de l'expditeur
    // si fichier de configuration classique
    else if (bufadr == adr_exped && *buf_lect == '/')
    {
        // on va fabriquer une adresse d'expditeur  partir
        // des 2 premires lignes du fichier de configuration

        // mmoriser la position courante dans le fichier de configuration
        posit = ftell (fconf);

        // et revenir au dbut de ce fichier
        rewind (fconf);

        // lire le nom du serveur pop
        fgets (buf_lect, sizeof (buf_lect), fconf);

        // si ce nom commence par pop
        if (*buf_lect == 'p' && buf_lect [1] == 'o' && buf_lect [2] == 'p')
        {
            // sauter le premier mot
            i = 3;

            while (buf_lect [i++] != '.')
                ;  // en sortant on est positionn aprs le '.'
        }
        else
            i = 0;

        // mmoriser la fin de l'adresse email
        fin_adr [0] = '@';

        j = 1;

        do
            fin_adr [j++] = buf_lect [i++];
        while (buf_lect [i] != '\n' && buf_lect [i]);

        fin_adr [j] = '\0';

        // lire le nom de l'utilisateur
        fgets (buf_lect, sizeof (buf_lect), fconf);

        // sauter la zone user dans la ligne lue
        i = 4;

        while (buf_lect [i] > ' ')
            i++;

        while (buf_lect [i] == ' ')
            i++;

        // fabriquer le dbut de l'adresse email
        j = 0;

        while (buf_lect [i] != '\n' && buf_lect [i])
            bufadr [j] = buf_lect [i];

        // rajouter la fin de cette adresse
        strcpy (bufadr + j, fin_adr);

        // se repositionner comme avant dans le fichier de configuration
        fseek (fconf, posit, SEEK_SET);
    }
    // sinon erreur non rcuprable
    else
        // "Adresse Email errone dans le fichier de configuration"
        errfatale ("ERR_ADR_MAIL", NULL);
}



/* rexpdie le mail slectionn  sa nouvelle adresse */

void copiemail (int numail)
{
    char bufw [80];  // buffer d'envoi d'une requte


    // initialisation de l'envoi SMTP

    // expditeur du message
    sprintf (bufw, "MAIL FROM: <%s>", adr_exped);
    envoie_smtp (bufw);
    lire_smtp ();

    // destinataire principal du message
    sprintf (bufw, "RCPT TO: <%s>", adr_dest);
    envoie_smtp (bufw);
    lire_smtp ();

    // si destinataire refus, on le signale
    if (buf_lect [0] != '2')
    {
        // Affichage de l'adresse  problme
        // "Destinataire %s refus\n"
        printf (message ("REFUS_DEST"), adr_dest);
        puts (buf_lect);

        // et on n'envoie aucun mail d'avertissement
        envoie_smtp ("RSET");
        lire_smtp ();
        return;  // mail non envoy
    }

    // prparation de l'envoi du message
    envoie_smtp ("DATA");
    lire_smtp ();

    // demande de lecture du message et rception de l'acquittement
    sprintf (bufw, "RETR %d", numail);
    env_pop (bufw);
    lire_pop ();

    // termin pour ce mail si erreur d'envoi cot serveur
    if (memcmp (buf_lect, "-ERR ", 5) == 0)
    {
        // Erreur serveur pour l'accs au mail
        aff_err_argnum ("ERREUR_SERVEUR", numail);
    }

    // rexpdition du mail
    do
    {
        // lire une ligne du mail
        lire_pop ();

        // expdier la ligne lue  l'autre serveur
        envoie_smtp (buf_lect);
    }
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');

    // rcuprer l'acquitement du serveur smrp
    lire_smtp ();
}



/* supprime le mail slectionn du serveur courant */

void detruitmail (int numail)
{
    char bufw [80]; // buffer d'envoi d'une requte de destruction


    // demande de destruction du mail sur le serveur initial
    sprintf (bufw, "DELE %d", numail);
    env_pop (bufw);
    lire_pop ();
}
