/*
   Fichier modepage.h
   Auteur Bernard Chardonneau
*/


/* taille par defaut d'une fentre */

#define defaut_ligne   25
#define defaut_colon   80


/* macros de gestion de l'affichage */

#define putseq(s)   printf ("%c[%s", ESC,s) // affiche squence d'chappement

#define debpage()   putseq ("H")   // se positionne en haut de page
#define baspage()   putseq ("99B") // se positionne en bas de page
#define effpage()   putseq ("J")   // efface la page  partir du curseur
#define effligne()  putseq ("K")   // efface la ligne  partir du curseur
#define insligne()  putseq ("L")   // insre une ligne au niveau ligne courante
#define montecurs() putseq ("A")   // remonte le curseur d'une ligne
#define lumnor()    putseq ("0m")  // affichage en luminosit normale


/* macros de gestion du clavier */

// lecture non bloquante caractre par caractre sans cho
#define mode_raw()  system ("stty -icanon min 0 time 5 -echo")

// lecture en mode normal (ligne par ligne) avec cho
#define mode_normal() system ("stty icanon echo")


/* prototypes des fonctions de la bibliothque modepage */

void clair();
void sombre();
void affpage ();
void monte (int n);
void descend (int n);
void lig_col ();
int  leccar ();
void execom (char *outil, char *fichier);
void attendre (int duree);


/* variables globales  l'application utilises par modepage
   (pour viter des tonnes de passages de paramtres) */

#ifdef modepage
     int nb_lignes;            // nombre de lignes mmorises
     int lignecour;            // numro de la ligne courante
     int lignepage, colonpage; // nombre ligne et colonnes de la page d'cran
     int lignecran;            // numro de ligne du curseur  l'cran
#else
     extern int nb_lignes;
     extern int lignecour;
     extern int lignepage, colonpage;
     extern int lignecran;
#endif
