/*
    Fichier numail.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ces 2 fonctions permettent de :
    - connaitre le numro du dernier mail tlcharg ou cr
    - mettre  jour le fichier qui mmorise ce numro.

    Les fonctions sont utilises aussi bien pour le tlchargement
    des mails : chargemail , chargepartaille , chargepartiel
    que pour la cration de mails  envoyer : cremail , repmail ,
    trsfmail .
*/

#include <stdio.h>
#include "messages.h"
#include "numail.h"
#include "szchemin.h"



/* retourne le numro du dernier mail tlcharg */

long num_dermail (char *dirmails)
{
    char ficnmail [szchemin + 7];
    FILE *fnmail;
    long numdermail;


    // accs au fichier contenant le numro du dernier mail
    sprintf (ficnmail, "%s/%s", dirmails, ficdir ("FIC_NUMAIL"));

    fnmail = fopen (ficnmail, "r");

    if (fnmail)
    {
        // recupration de ce numro
        fscanf (fnmail, "%ld", &numdermail);
        fclose (fnmail);

        // retour du numro lu
        return (numdermail);
    }
    else
        // fichier absent : aucun mail n'a encore t tlcharg ou cr
        return (-1L);
}


/* mmorise le numro du dernier mail tlcharg ou cr */

void sauv_num_dermail (char *dirmails, long numail)
{
    char ficnmail [szchemin + 7];
    FILE *fnmail;


    // accs en criture du fichier contenant le numro du dernier mail
    sprintf (ficnmail, "%s/%s", dirmails, ficdir ("FIC_NUMAIL"));

    fnmail = fopen (ficnmail, "w");

    if (fnmail)
    {
        // mise  jour du numro
        fprintf (fnmail, "%ld", numail);
        fclose (fnmail);
    }
    else
        // "Impossible de mettre  jour le fichier %s"
        aff_err_arg ("IMPOS_MAJ_FICH", ficnmail);
}
