/*
    Fichier repmail.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme prpare une rponse pour le fichier mail pass en paramtre
    Le chemin d'accs au fichier peut tre absolu ou relatif.

    A partir du squelette gnr, la rponse se fait grace  l'diteur vi

    Le fichier obtenu est ensuite stoqu dans le rpertoire des mails  envoyer
    Pour que cela soit possible, il faut :
    - soit que la commande repmail soit lance depuis la chaine vmail...
    - soit prciser le nom du rpertoire de l'arborescence des mails
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "messages.h"
#include "buflect.h"
#include "fmail.h"
#include "encodage.h"
#include "trtentete.h"
#include "trtligne.h"
#include "groupeligne.h"
#include "trtbordure.h"
#include "trtsection.h"
#include "numail.h"
#include "genentete.h"
#include "modepage.h"
#include "carspe.h"


#define  szbuf    160   // taille des tableaux mmorisant les champs de l'entte


/* prototypes */
void gene_entete (char *nomfic);
void gene_enteterep (char *nomfic);
void gene_mesrep ();
void copie_texte ();
void aff_debliste (long pos_deblig);
void copchamp (long pos_deblig, int conversion);
void genligne (char *buffer);


/* variable globale au source
   (pour viter des passages de paramtres) */

long numail; // numro que prendra le mail gnr
// caractre signifcatif de la variable d'environnement libremail_xorig
char xorig;


/* programme principal */

int main (int nbarg, char *varg[])
{
    char ficmail [szchemin];  // fichier mail de rponse
    char fentete [szchemin];  // fichier contenant l'entete du message
    char commande [szchemin]; // commande d'appel de l'diteur
    char *editeur;            // diteur utilis pour saisir la rponse
    char *varenv_xorig;       // variable d'environnement libremail_xorig


    // rcupration du nom de l'excutable
    memcom (*varg);

    // si nombre d'arguments correct
    if (--nbarg == 1 || nbarg == 2)
    {
        // ouvrir le fichier mail auquel on doit rpondre
        fmail = fopen (varg [1], "r");

        // termin si le fichier n'a pas pu tre ouvert
        if (! fmail)
        {
            if (access (varg [1], 0) == 0)
                // "Problme d'accs au fichier %s"
                errfatale ("ACCES_FICHIER", varg [1]);
            else
                // "Fichier %s inexistant"
                errfatale ("FICH_INEXISTANT", varg [1]);
        }
    }
    // sinon, rappel de la syntaxe de la commande
    else
        // "Syntaxe : %s nom_fichier_mail [rpertoire_emails]"
        psyntaxe ("SYNT_REP/TRSF-MAIL");

    // rcuprer la partie significative de la variable libremail_xorig
    varenv_xorig = getenv ("libremail_xorig");

    if (varenv_xorig)
        xorig = tolower (*varenv_xorig);
    else
        xorig = '\0';

    // passer en mode standard pour les lectures au clavier
    mode_normal ();

    // rcuprer le nom du rpertoire des mails  envoyer
    recupdirenv (nbarg, varg [2]);

    // crer un nom de fichier temporaire pour l'entte du mail
    // il a toujours le mme nom pour viter de polluer le
    // rpertoire d'envoi en cas de fausse manoeuvre oprateur (^C)
    sprintf (fentete, "%s/tmp-ent", direnv);

    // fabriquer l'entte du mail de rponse
    gene_entete (fentete);

    // crer un nom de fichier temporaire pour le message
    sprintf (ficmail, "%s/tmp-mes", direnv);

    // fabriquer le message de rponse
    gene_enteterep (ficmail);

    // Choix de l'diteur de textes
    editeur = getenv ("EDITOR");

    if (! editeur)
        editeur = "vi";

    // c'est au tour de l'utilisateur de rpondre au mail
    sprintf (commande, "%s %s", editeur, ficmail);
    system (commande);

    // mmoriser les dates et heure d'envoi du message
    ajout_date (fentete);

    // on va regrouper l'entte et le message dans un fichier numrot dfinitif
    fusionner (fentete, numail, ficmail);

    // mettre  jour le fichier numail du rpertoire de sortie
    sauv_num_dermail (direnv, numail);

    // ajouter la signature au message, si elle existe
    ajout_sign (ficmail);

    // modification avant envoi ?
    // "Voulez vous modifier le fichier complet avant envoi ? "
    affiche_msg_nocr ("MAJ_MAIL_PRET");

    if (tolower (getchar ()) != 'n')
    {
        // si oui, appeler l'diteur
        sprintf (commande, "%s %s", editeur, ficmail);
        system (commande);
    }

    // pour faire plaisir  gcc qui veut une fonction main de type int
    return (0);
}


/* lit l'entte du message choisi et fabrique celle de la rponse */

void gene_entete (char *nomfic)
{
    long pos_deblig;  // position dans le fichier en dbut de ligne courante
    // position dans le fichier des champs pouvant tenir sur plusieurs lignes
    long posTo = -1, posCc = -1, posSubject = -1, posRef = -1;
    // mmorisation directe d'autres champs
    // grosse taille des buffers pour ne pas tronquer une adresse
    // de type confirmation d'inscription  une mailing list
    char bufFrom [szbuf], bufXorig [szbuf], bufReply [szbuf], bufMesid [szbuf];
    char *bufexped;       // pour traitement commun de bufFrom et bufXorig;
    char reponse [10];    // rponse  une question
    int  choix, choixmax; // choix des destinataires
    int  i, j;            // compteurs


    // fabriquer et ouvrir en criture le fichier d'entte
    fdest = fopen (nomfic, "w");

    if (! fdest)
        // "Impossible de crer un fichier d'entte %s"
        errfatale ("IMPOS_CRE_ENTETE", nomfic);

    // initialisation
    *bufFrom    = '\0';
    *bufXorig   = '\0';
    *bufReply   = '\0';
    *bufMesid   = '\0';

    // lecture et mmorisation de l'entte du message
    do
    {
        // rcuprer la position en dbut de ligne
        pos_deblig = ftell (fmail);

        // lire une ligne de l'entte du message
        lire_fmail ();

        // pour viter un dbordement de buffer lors d'une copie
        buf_lect [szbuf - 1] = '\0';

        // reprage des champs importants et mmorisation
        // de leur contenu ou de leur position
        if (start ("From") || (start ("X-Original-From") && xorig != 'n'))
        {
            // initialiser bufexped avec bufFrom ou bufXorig
            if (toupper (*buf_lect) == 'F')
                bufexped = bufFrom;
            else
                bufexped = bufXorig;

            // convertir les caractres spciaux ventuels
            majlignentete ();

            // analyse et copie dans le bufFrom
            // on n'utilise pas memconvbuf parce qu'il tronque  80 caractres
            i = 0;
            j = 0;

            do
            {
                // recopier un caractre
                bufexped [i] = buf_lect [i];

                // mmoriser la prsence d'une adresse Email dans la ligne
                if (buf_lect [i] == '@')
                    j = i;
            }
            while (buf_lect [i++]);

            // si aucune adresse email valide n'a t trouve dans la ligne
            if (buf_lect [j] != '@')
            {
                // lire la ligne suivante
                lire_fmail ();

                // convertir les caractres spciaux ventuels
                majlignentete ();

                // et copie dans le buffer  la suite de la ligne prcdente
                j = 0;
                i --;

                while (buf_lect [j] && i < szbuf - 1)
                {
                    // recopier un caractre et passer au suivant
                    bufexped [i++] = buf_lect [j++];
                }

                // terminer la chaine de caractres
                bufexped [i] = '\0';
            }
        }
        else if (start ("To"))
            posTo = pos_deblig;      // on mmorise la position de la ligne
        else if (start ("Cc"))
            posCc = pos_deblig;      // on mmorise la position de la ligne
        else if (start ("Reply-To"))
        {
            // pas de conversion des lignes contenant une adresse Email
            // (on vite ainsi de supprimer les _ de certaines adresses)
            strcpy (bufReply, buf_lect);
        }
        else if (start ("Subject"))
            posSubject = pos_deblig; // on mmorise la position de la ligne
        else if (start ("Message-Id"))
        {
            // on rcupre juste la valeur du Message-Id sans conversion
            // elle servira  gnrer les champs In-Reply-To et Reference
            if (buf_lect [11] == ' ')
                strcpy (bufMesid, buf_lect + 12);
            else
                strcpy (bufMesid, buf_lect + 11);
        }
        else if (start ("Reference"))
            posRef = pos_deblig;      // on mmorise la position de la ligne
    }
    while (buf_lect [0] != '\0');  // lecture entte termine si ligne vide

    // rcuprer l'adresse de celui qui rpond au mail
    lire_exped ();

    // chercher le numro du mail que l'on va crer
    numail = num_dermail (direnv) + 1;

    // gnration du champ Message-Id
    gen_mes_id (fdest, numail, buf_lect);

    // mettre l'expditeur du message
    ajouts = 0;
    ajout_adr (buf_lect, "From");
    fputc ('\n', fdest);

    // choix des destinataires
    // pas de slection manuelle des adresses, mais jusqu' 6 choix
    // en fonction des caractristiques du mail auquel on rpond
    // "\nRpondre  :\n"
    affiche_msg ("CHOIX_REP-0");

    // si le champ X-Original_From est prsent dans le mail
    if (*bufXorig)
    {
        // "1) Le vrai expditeur :%s\n\n"
        // "2) Le vrai expditeur + celui qui rpond en copie : %s\n\n"
        // "3) Le vrai expditeur + destinataires en copie  choisir\n"
        printf (message ("CHOIX_REP-1A"), bufXorig + 16);
        printf (message ("CHOIX_REP-2A"), buf_lect);
        affiche_msg ("CHOIX_REP-3A");
    }
    // sinon (le champ From contient l'expditeur)
    else
    {
        // "1) L'expditeur :%s\n\n"
        // "2) L'expditeur + celui qui rpond en copie : %s\n\n"
        // "3) L'expditeur + destinataires en copie  choisir\n"
        printf (message ("CHOIX_REP-1"), bufFrom + 5);
        printf (message ("CHOIX_REP-2"), buf_lect);
        affiche_msg ("CHOIX_REP-3");
    }

    // "4) Au(x) destinataire(s) principal/aux"
    affiche_msg ("CHOIX_REP-4");

    // cette liste peut tenir sur plusieurs lignes
    aff_debliste (posTo);
    putchar ('\n');

    // 2 libells galement pour le choix 5
    if (*bufXorig)
        // "5) Le vrai expditeur + destinataire(s) principal/aux"
        affiche_msg ("CHOIX_REP-5A");
    else
        // "5) L'expditeur + destinataire(s) principal/aux"
        affiche_msg ("CHOIX_REP-5");

    // ces choix ne sont rajouts que s'ils sont possibles
    if (*bufReply)
    {
        // "6) A l'adresse pour rpondre :%s\n"
        // "7) A l'adresse pour rpondre + celui qui rpond en copie\n\n"
        putchar ('\n');
        printf (message ("CHOIX_REP-6"), bufReply + 9);
        putchar ('\n');
        affiche_msg ("CHOIX_REP-7");
        choixmax = 7;
    }
    else
        choixmax = 5;

    if (*bufXorig)
    {
        // "8) L'expditeur falsifi :%s\n\n"
        // "9) L'expditeur falsifi + destinataires en copie  choisir\n"
        printf (message ("CHOIX_REP-8"), bufFrom + 5);
        affiche_msg ("CHOIX_REP-9");
        choixmax = 9;
    }

    // choix oprateur
    do
    {
        // "Votre choix ? "
        putchar ('\n');
        affiche_msg_nocr ("VOTRE_CHOIX");
        fgets (reponse, sizeof (reponse), stdin);
        choix = atoi (reponse);
    }
    while (choix < 1 || choix > choixmax);

    // gnration de la liste des destinataires principaux
    // (sauf pour le choix 4)
    switch (choix)
    {
        case 1 :
        case 2 :
        case 3 :
        case 5 : // expditeur ou vrai expditeur
                 if (*bufXorig)
                     fprintf (fdest, "To:%s", bufXorig + 16);
                 else
                     fprintf (fdest, "To:%s", bufFrom + 5);

                 // terminer la ligne pour les choix 1  3
                 if (choix != 5)
                     fputc ('\n', fdest);
                 break;

        case 6 :
        case 7 : // adresse pour rpondre
                 fprintf (fdest, "To:%s\n", bufReply + 9);
                 break;

        case 8 :
        case 9 : // expditeur falsifi
                 fprintf (fdest, "To:%s\n", bufFrom + 5);
                 break;
    }

    // gnration de la liste des destinataires en copie
    // (ou destinataire principaux pour choix 4 et 5)
    switch (choix)
    {
        case 2 :
        case 7 : // celui qui rpond en copie
                 lire_exped ();
                 ajouts = 0;
                 ajout_adr (buf_lect, "Cc");
                 fputc ('\n', fdest);
                 break;

        case 3 :
        case 9 : // destinataires en copie  choisir
                 // charger le carnet d'adresses
                 charge_carnet_adr ();

                 // configurer la liaison clavier
                 // pour lecture directe avec timeout
                 mode_raw ();

                 // et choisir des destinataires
                 choixdest ("Cc");

                 // on repasse en mode saisie normale
                 mode_normal ();
                 break;

        case 4 :
        case 5 : // destinataires principaux
                 // se positionner sur le champ  copier
                 fseek (fmail, posTo, SEEK_SET);

                 // lire et copier la premire ligne
                 lire_fmail ();

                 // en tenant compte ventuellement de la ligne prcdente
                 if (choix == 4)
                     fputs (buf_lect, fdest);
                 else
                     fprintf (fdest, ",\n\t%s", buf_lect + 4);

                 // tester la ligne suivante
                 lire_fmail ();

                 // recopier jusqu' la fin de la liste
                 while (*buf_lect == ' ' || *buf_lect == '\t')
                 {
                     fprintf (fdest, "\n%s", buf_lect);
                     lire_fmail ();
                 }

                 // terminer proprement la liste des destinataires
                 fputc ('\n', fdest);

                 // rajout  la demande des destinataires en copie
                 //  la suite de la liste des destinataires principaux
                 if (posCc >= 0 && (choix == 4 || choix == 5))
                 {
                     // "\nDestinataires en copie :"
                     affiche_msg ("AJOUT_DESTCOP-1");
                     aff_debliste (posCc);

                     // "Voulez vous les rajouter ? "
                     affiche_msg_nocr ("AJOUT_DESTCOP-2");
                     fgets (reponse, sizeof (reponse), stdin);

                     // traitement rponse valable en de nombreuses langues
                     // si la rponse ne commence pas par 'n', c'est oui
                     // (ceux qui obligent  rpondre 'y' sont de gros nuls)
                     if (tolower (*reponse) != 'n')
                     {
                         // se positionner sur le champ  copier
                         fseek (fmail, posCc, SEEK_SET);

                         // lire la premire ligne
                         lire_fmail ();

                         // copier jusqu' la fin de la liste
                         do
                         {
                             fprintf (fdest, "%s\n", buf_lect);
                             lire_fmail ();
                         }
                         while (*buf_lect == ' ' || *buf_lect == '\t');
                     }
                 }
                 break;
    }

    // gnration du champ Subject
    if (posSubject >= 0)
    {
        // lire la ligne contenant le sujet
        fseek (fmail, posSubject, SEEK_SET);
        lire_fmail ();

        // convertir les caractres spciaux ventuels
        // c'est dans envmail qu'on rencodera ventuellement ce champ
        majlignentete ();

        // si la ligne du sujet n'est pas vide
        if (strlen (buf_lect) > 9)
        {
            // si le sujet du mail commence par les lettres re
            if (tolower (buf_lect [9]) == 'r' && tolower (buf_lect [10]) == 'e')
            {
                // si le sujet commence par Re: , RE: , re: etc...
                if (buf_lect [11] == ':')
                    // On utilise la syntaxe la plus courante Re:
                    fprintf (fdest, "Subject: Re:%s", buf_lect + 12);

                // sinon si le sujet commence par Re : , RE : , re : etc...
                else if (buf_lect [11] == ' ' && buf_lect [12] == ':')
                    // on supprime le blanc avant le :
                    fprintf (fdest, "Subject: Re:%s", buf_lect + 13);

                // sinon (les lettres re ne sont pas suivies d'un :
                else
                    // on rajoute un Re: en dbut de sujet
                    fprintf (fdest, "Subject: Re: %s", buf_lect + 9);
            }
            // sinon
            else
                // on rajoute un Re: en dbut de sujet
                fprintf (fdest, "Subject: Re: %s", buf_lect + 9);

            // lire la ligne suivante
            lire_fmail ();
        }
        else
        {
            // on va vrifier si le sujet est sur la ligne suivante
            lire_fmail ();

            // le libell du sujet dpendra du rsultat du test
            if (*buf_lect == ' ' || *buf_lect == '\t')
                fputs ("Subject: Re: ", fdest);
            else
            {
                // "Subject: Rponse  message sans objet prcis"
                fputs (message ("SUJET_VIDE"), fdest);
            }
        }

        // tantque c'est aussi une ligne du sujet
        while (*buf_lect == ' ' || *buf_lect == '\t')
        {
            // convertir les caractres spciaux ventuels
            majlignentete ();

            // rajouter le contenu de la ligne au sujet
            fputs (buf_lect + 1, fdest);

            // et lire la ligne suivante
            lire_fmail ();
        }

        // terminer la ligne contenant le sujet
        fputc ('\n', fdest);
    }
    else
    {
        // "Subject: Rponse  message sans objet prcis"
        fputs (message ("SUJET_VIDE"), fdest);
        fputc ('\n', fdest);
    }

    // si le mail auquel on rpond avait un identificateur
    if (*bufMesid)
    {
        // on va gnrer le champ Reference

        // s'il y avait dj un champ Reference
        if (posRef >= 0)
        {
            // se positionner sur ce champ
            fseek (fmail, posRef, SEEK_SET);

            // lire la premire ligne
            lire_fmail ();

            // copier jusqu' la fin de la liste
            do
            {
                fprintf (fdest, "%s\n", buf_lect);
                lire_fmail ();
            }
            while (*buf_lect == ' ' || *buf_lect == '\t');

            // rajouter la dernire rfrence
            fprintf (fdest, "           %s\n", bufMesid);
        }
        // sinon
        else
            // crer un champ rfrence
            fprintf (fdest, "Reference: %s\n", bufMesid);

        // gnrer le champ In-Reply-To
        fprintf (fdest, "In-Reply-To: %s\n", bufMesid);
    }

    // jeu de caractres du message
    fprintf (fdest, "Content-Type: text/plain; charset=");

    if (util_utf8 ())
        fprintf (fdest, "UTF-8;\n");
    else
        fprintf (fdest, "ISO-8859-15;\n");

    // mode d'encodage
    fprintf (fdest, "Content-Transfer-Encoding: 8bit\n");

    // variante (qui suppose des conversions avant envoi du mail)
    // fprintf (fdest, "Content-Transfer-Encoding: quoted-printable\n");

    // un copyright qui n'est pas celui d'Outlook ;-))
    // "libremail : logiciel libre multilingue"
    fprintf (fdest, "User-Agent: libremail : %s\n",
                     message ("QUALIF_LIBREMAIL"));

    // permettra de relire ce fichier
    fclose (fdest);
}



/* lit le message choisi et fabrique le squelette de la rponse
   cette fonction traite essentiellement l'entte du mail
   puis appelle gene_mesrep pour le rajout du corps du mail */

void gene_enteterep (char *nomfic)
{
    long pos_deblig;  // position dans le fichier en dbut de ligne
    // position dans le fichier mail des principaux champs de l'entte
    long posDate, posFrom, posXorig, posTo, posCc, posReply,
         posSubject, posContent, posUseAgent;


    // fabriquer et ouvrir en criture le fichier mail
    fdest = fopen (nomfic, "w");

    if (! fdest)
        // "Impossible de crer le fichier mail %s"
        errfatale ("IMPOS_CRE_FICMAIL", nomfic);

    // initialisation
    posDate     = -1;
    posFrom     = -1;
    posXorig    = -1;
    posTo       = -1;
    posCc       = -1;
    posReply    = -1;
    posSubject  = -1;
    posContent  = -1;
    posUseAgent = -1;

    // on revient au dbut du fichier mail
    rewind (fmail);

    // lecture de l'entte et mmorisation de la position des champs importants
    do
    {
        // rcuprer la position en dbut de ligne
        pos_deblig = ftell (fmail);

        // lire une ligne de l'entte du message
        lire_fmail ();

        // reprage des champs importants et mmorisation de leur position
        if (start ("X-Mailer") || start ("User-Agent"))
            posUseAgent = pos_deblig;
        else if (start ("Date"))
            posDate = pos_deblig;
        else if (start ("From"))
            posFrom = pos_deblig;
        else if (start ("X-Original-From") && xorig != 'n')
            posXorig = pos_deblig;
        else if (start ("To"))
            posTo = pos_deblig;
        else if (start ("Cc"))
            posCc = pos_deblig;
        else if (start ("Reply-To"))
            posReply = pos_deblig;
        else if (start ("Subject"))
            posSubject = pos_deblig;
        else if (start ("Content-Type"))
            posContent = pos_deblig;
        else if (start ("Content-Transfer-Encoding"))
            mem_encodage ();
    }
    while (buf_lect [0] != '\0');  // lecture entte termine si ligne vide

    // sauter des lignes pour rponse avant le message
    fputc ('\n', fdest);
    fputc ('\n', fdest);

    // rappel des caractristiques du message auquel on rpond
    if (posUseAgent >= 0)
        copchamp (posUseAgent, 0);
    if (posDate >= 0)
        copchamp (posDate, 0);
    if (posFrom >= 0 && (posXorig < 0 || xorig == '2'))
        copchamp (posFrom, 1);
    if (posXorig >= 0)
        copchamp (posXorig, 1);
    if (posTo >= 0)
        copchamp (posTo, 1);
    if (posCc >= 0)
        copchamp (posCc, 1);
    if (posReply >= 0)
        copchamp (posReply, 1);
    if (posSubject >= 0)
        copchamp (posSubject, 1);

    // rcuprer le type principal du message et ses caractristiques
    recup_typeorig (posContent);

    // revenir au dbut du corps du message
    fseek (fmail, pos_deblig, SEEK_SET);
    lire_fmail ();

    // copie du contenu du mail
    if (ctypeorig & Multipart)
        // il faudra analyser les sections
        gene_mesrep ();
    else
        // une simple copie du texte suffit
        copie_texte ();

    // gnration automatique termine
    fclose (fdest);
}


/* affiche les premires lignes d'une liste de destinataires
   (champs To: ou Cc:) du message auquel on rpond */

void aff_debliste (long pos_deblig)
{
    int i; // compteur

    // se positionner sur le champ  afficher
    fseek (fmail, pos_deblig, SEEK_SET);

    // lire et afficher la premire ligne
    lire_fmail ();
    majlignentete ();
    printf ("  ");
    puts (buf_lect + 3);

    // tester la ligne suivante
    lire_fmail ();
    i = 0;

    // et continuer l'affichage si ncessaire
    while ((*buf_lect == ' ' || *buf_lect == '\t') && ++i < 9)
    {
        majlignentete ();
        printf ("   ");
        puts (buf_lect + 1);
        lire_fmail ();
    }

    // on abrge l'affichage si la liste est trop longue
    if (i >= 9)
        puts ("   (...)");
}


/* recopie un champ de l'entte d'une ou plusieurs lignes
   repr  partir de sa position dans le fichier mail */

void copchamp (long pos_deblig, int conversion)
{
    // se positionner sur la ligne contenant le champ
    fseek (fmail, pos_deblig, SEEK_SET);

    // lire cette ligne
    lire_fmail ();

    // rpter
    do
    {
        // interprter si ncessaire les caractres spciaux
        if (conversion)
            majlignentete ();

        // et afficher la ligne
        fprintf (fdest, "> %s", buf_lect);

        // en tenant compte d'un ventuel \n dans le buffer
        if (buf_lect [strlen (buf_lect) - 1] != '\n')
            fputc ('\n', fdest);

        // lire la ligne suivante
        lire_fmail ();
    }
    // jusqu' la dernire ligne du champ
    while (*buf_lect == ' ' || *buf_lect == '\t');
}


/* lecture et copie du contenu d'un mail en mode multipart */

void gene_mesrep ()
{
    // mmorisation des modes multipart trouvs
    int multipmixed = 0, multipalter = 0, multiprel = 0, multiprep = 0;


    // mmoriser tous les modes multipart imbriqus
    do
    {
        switch (ctype)
        {
            case MultipMixed : multipmixed = 1;
                               break;

            case MultipAlter : multipalter = 1;
                               break;

            case MultipRep   : multiprep   = 1;
                               break;

            case MultipRel   : multiprel   = 1;
        }

        // passer  la section suivante
        prochaine_section ();

        // rcuprer ses caractristiques
        recup_infos_section ();
    }
    while ((ctype & Multipart) && lire_fmail ());

    // indiquer si le mail peut contenir des pices jointes
    if (multipmixed)
        // "Pice(s) jointes(s) probable(s)"
        genligne (message ("PJ_PROBABLE"));

    // si une section multipart/alternative a t trouve, se positionner
    // (si l'on n'y est pas) sur la section text/plain du mail
    if (multipalter)
        posit_texte ();

    // gnrer une ligne de sparation avec l'entte
    genligne ("\n");

    // si structure du mail non conforme, message d'erreur
    if (! lire_fmail ())
        // "Pas de zone texte dans ce mail !!!"
        genligne (message ("MANQUE_ZONE_TEXTE"));

    // lecture et mmorisation du corps du message
    do
    {
        // mise en forme et mmorisation de la dernire ligne lue
        majligne ();

        if (buf_lect [strlen (buf_lect) - 1] != '\n')
            regroupeligne (buf_lect);
        else
            genligne (buf_lect);

        // et lecture de la suivante
        if (! lire_fmail ())
            return;   // on sort en fin de fichier

        // si mode multipart/report, on saute les enttes de section
        if (multiprep && nbordures && surbordure ())
        {
            do
                lire_fmail ();
            while (*buf_lect);
        }
    }
    // on s'arrte en fin de fichier, ou sur la prochaine bordure
    while (nbordures == 0 || ! surbordure ());

    // si mode multipart mixed on va lister les pices jointes
    if (ctypeorig == MultipMixed)
        liste_pj ();
}



/* lecture et copie d'un mail de type text/plain */

void copie_texte ()
{
    // si texte encod base 64
    if (encodage_texte == Base64)
        // gnrer une ligne de sparation avec l'entte
        genligne ("\n");

    // rpter
    do
    {
        // mise en forme de la dernire ligne lue
        majligne ();

        // mmorisation de cette ligne
        if (buf_lect [strlen (buf_lect) - 1] != '\n')
            regroupeligne (buf_lect);
        else
            genligne (buf_lect);

        // et lecture de la suivante
    }
    // on s'arrte en fin de fichier
    while (lire_fmail ());
}



/* mmorise une ligne du mail */

void genligne (char *buffer)
{
    char * nouvligne;
    int  taille_ligne;
    int  i;


    // rcuprer la longueur de la ligne
    taille_ligne = strlen (buffer);

    // si ligne longue
    if (taille_ligne > 80)
    {
        // on tente de la tronquer  moins de 80 car
        i = 70;

        // chercher un blanc pour passer  la ligne
        // ou un \n rsultant d'un abus de l'encodage Mime
        while (i > 0 && buffer [i] != ' ' && buffer [i] != '\n')
            i--;

        // si pas de blanc trouv
        if (i == 0)
        {
            // on en cherche un dans l'autre sens
            i = 70;

            while (i < taille_ligne && buffer [i] != ' ' && buffer [i] != '\n')
                i++;
        }

        // mmoriser la taille de la ligne tronque
        taille_ligne = i;
    }

    // tenir compte d'un '\n' ventuel en cours de ligne !
    // (dans le cas d'un encodage quoted-printable non conforme
    // ou d'un encodage base64)
    for (i = 0; i < taille_ligne - 1; i++)
        if (buffer [i] == '\n')
            taille_ligne = i;

    // recopier les donnes dans ce tableau
    fputc ('>', fdest);

    if (taille_ligne > 1)
        fputc (' ', fdest);

    for (i = 0; i < taille_ligne; i++)
        fputc (buffer [i], fdest);

    // si la ligne a t tronque
    if (taille_ligne < strlen (buffer))
    {
        // gnrer un passage  la ligne
        fputc ('\n', fdest);

        // et traiter la suite
        genligne (buffer + taille_ligne + 1);
    }
}
